Index: /trunk/src/lib/network/zip.cc
===================================================================
--- /trunk/src/lib/network/zip.cc	(revision 7954)
+++ /trunk/src/lib/network/zip.cc	(revision 7954)
@@ -0,0 +1,253 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+#include "zip.h"
+
+#include "src/lib/util/loading/resource_manager.h"
+
+/**
+ *  the singleton reference to this class
+ */
+Zip* Zip::singletonRef = NULL;
+
+
+/**
+ * standard constructor
+ */
+Zip::Zip()
+{
+
+}
+
+
+/**
+ * @brief standard deconstructor
+ */
+Zip::~Zip()
+{
+  Zip::singletonRef = NULL;
+}
+
+/**
+ * load a dictionary to unzip. you can load more than one dictionary
+ * if you call unzip with data from zip without loading the same dictionary
+ * used with zip unzip will fail
+ * @param name name of dictionary
+ * @return true on success
+ */
+bool Zip::loadDictionary( std::string name )
+{
+  std::string fileName = ResourceManager::getInstance()->getDataDir();
+  //PRINTF(0)("datadir: %s\n", fileName.c_str());
+  fileName = fileName + "/dicts/" + name;
+  //PRINTF(0)("filename: %s\n", fileName.c_str());
+  
+  FILE * f = fopen( fileName.c_str(), "r" );
+  
+  if ( !f )
+  {
+    PRINTF(1)("Could not open %d\n", fileName.c_str());
+    return false;
+  }
+  
+  byte buf[1024];
+  
+  int nBytesRead = 0;
+  
+  while ( !feof( f ) )
+  {
+    nBytesRead += fread( buf, 1, sizeof(buf), f );
+  }
+  
+  DictionaryEntry entry;
+  
+  entry.dictLen = nBytesRead;
+  entry.dict = new Byte[nBytesRead];
+  
+  fseek( f, 0, SEEK_SET );
+  
+  assert( fread( entry.dict, 1, nBytesRead, f ) == nBytesRead );
+  
+  entry.adler = adler32( adler32( 0L, Z_NULL, 0 ), entry.dict, nBytesRead );
+  
+  dicts.push_back( entry );
+  
+  PRINTF(3)("Loaded dictionary '%s' with adler = %d\n", name.c_str(), entry.adler );
+  
+  return true;
+}
+
+/**
+ * zip data. you must call loadDictionary before
+ * @param from data to compress
+ * @param fromLength length of data to compress
+ * @param to pointer to compressed data
+ * @param maxLength max bytes to compress
+ * @param dict dictionary to use. default is 0
+ * @return num bytes writen to to
+ */
+int Zip::zip( byte * from, int fromLength, byte * to, int maxLength, int dict )
+{
+  if ( dicts.size() < dict+1 )
+  {
+    PRINTF(1)("you cannot use dict nr %d. num dicts: %d\n", dict, dicts.size() );
+    return -1;
+  }
+  
+  int res;
+
+  z_stream strm;
+
+  strm.zalloc = Z_NULL;
+  strm.zfree = Z_NULL;
+  strm.opaque = Z_NULL;
+
+  res = deflateInit( &strm, 9 );
+
+  if ( res != Z_OK )
+  {
+    PRINTF(1)("deflateInit error: %s\n", strm.msg);
+    return -1;
+  }
+
+  res = deflateSetDictionary( &strm, (Bytef*)(dicts[dict].dict), dicts[dict].dictLen );
+	
+  if ( res != Z_OK )
+  {
+    PRINTF(1)("deflateSetDictionary error: %s\n", strm.msg);
+    return -1;
+  }
+
+  strm.next_out = (Bytef*)to;
+  strm.avail_out = maxLength;
+  assert( strm.total_out == 0 );
+  strm.next_in = (Bytef*)from;
+  strm.avail_in = fromLength;
+  assert( strm.total_in == 0 );
+
+  res = deflate( &strm, Z_FINISH );
+	
+  if ( res != Z_STREAM_END )
+  {
+    PRINTF(1)("buffer to small or deflate error: %s\n", strm.msg);
+    return -1;
+  }
+
+  assert( strm.avail_out != 0 );
+  assert( strm.avail_in == 0 );
+
+  int zippedlen = strm.total_out;
+
+  res = deflateEnd( &strm );
+	
+  if ( res != Z_OK )
+  {
+    if ( res == Z_STREAM_ERROR )
+      PRINTF(1)("deflateEnd error: Z_STREAM_ERROR\n");
+    else if ( res == Z_DATA_ERROR )
+      PRINTF(1)("deflateEnd error: Z_DATA_ERROR %s\n", strm.msg);
+    else
+      PRINTF(1)("deflateEnd error: dont know\n");
+    
+    return -1;
+  }
+  
+  return zippedlen;
+
+}
+
+/**
+ * uncompress data. same dict as used in zip must be loaded
+ * @param from compressed data
+ * @param fromLength length of compressed data
+ * @param to buffer to copy uncompressed data to
+ * @param maxLength max bytes to copy to to
+ * @return num bytes writen to to
+ */
+int Zip::unZip( byte * from, int fromLength, byte * to, int maxLength )
+{
+  z_stream strm;
+  int res = 0;
+  
+  strm.zalloc = Z_NULL;
+  strm.zfree = Z_NULL;
+  strm.opaque = Z_NULL;
+
+  res = inflateInit( &strm );
+
+  if ( res != Z_OK )
+  {
+    PRINTF(1)("inflateInit error: %s\n", strm.msg);
+    return -1;
+  }
+	
+  strm.next_out = (Bytef*)to;
+  strm.avail_out = maxLength;
+  assert( strm.total_out == 0 );
+  strm.next_in = (Bytef*)from;
+  strm.avail_in = fromLength;
+  assert( strm.total_in == 0 );
+
+  assert( inflate( &strm, Z_NO_FLUSH ) == Z_NEED_DICT );
+	
+  int dictId = -1;
+  
+  for ( int i = 0; i < dicts.size(); i++ )
+  {
+    if ( dicts[i].adler == strm.adler )
+    {
+      dictId = i;
+      break;
+    }
+  }
+  
+  if ( dictId == -1 )
+  {
+    PRINTF(1)("Could not find dict used to compress this packet! ( adler = %d )\n", strm.adler);
+    return -1;
+  }
+      
+  res = inflateSetDictionary( &strm, (Bytef*)dicts[dictId].dict, dicts[dictId].dictLen );
+	
+  if ( res != Z_OK )
+  {
+    PRINTF(1)("inflateSetDictionary error: %s\n", strm.msg);
+    return -1;
+  }
+
+
+  res = inflate( &strm, Z_FINISH );
+	
+  if ( res != Z_STREAM_END )
+  {
+    PRINTF(1)("inflate error: %s\n", strm.msg);
+    return -1;
+  }
+
+  assert( strm.avail_out != 0 );
+  assert( strm.avail_in == 0 );
+
+  int unzippedlen = strm.total_out;
+
+  res = inflateEnd( &strm );
+	
+  if ( res != Z_OK )
+  {
+    PRINTF(1)("inflateEnd error: %s\n", strm.msg);
+    return -1;
+  }
+  
+  return unzippedlen;
+}
Index: /trunk/src/lib/network/zip.h
===================================================================
--- /trunk/src/lib/network/zip.h	(revision 7954)
+++ /trunk/src/lib/network/zip.h	(revision 7954)
@@ -0,0 +1,43 @@
+/*!
+ * @file zip.h
+ * @brief Definition of the Zip singleton Class
+ */
+
+#ifndef _ZIP_H
+#define _ZIP_H
+
+#include <zlib.h>
+#include <string>
+#include <vector>
+
+#include "netdefs.h"
+
+struct DictionaryEntry
+{
+  byte * dict;
+  int    dictLen;
+  uLong  adler;
+};
+
+//! A class for compressing/uncompressing packes.
+class Zip 
+{
+  public:
+    virtual ~Zip(void);
+    /** @returns a Pointer to the only object of this Class */
+    inline static Zip* getInstance(void) { if (!singletonRef) singletonRef = new Zip();  return singletonRef; };
+    
+    bool loadDictionary( std::string name );
+    int zip( byte * from, int fromLength, byte * to, int maxLength, int dict = 0 );
+    int unZip( byte * from, int fromLength, byte * to, int maxLength );
+    
+    int getDictCount(){ return dicts.size(); }
+
+  private:
+    Zip();
+    static Zip* singletonRef;
+    
+    std::vector<DictionaryEntry> dicts;
+};
+
+#endif /* _PROTO_SINGLETON_H */
Index: /trunk/src/orxonox.cc
===================================================================
--- /trunk/src/orxonox.cc	(revision 7953)
+++ /trunk/src/orxonox.cc	(revision 7954)
@@ -91,4 +91,8 @@
 REGISTER_ARG_FLAG( _, write_bt_to_file, "misc", "bt-to-file", "Write backtrace to file", "1");
 #endif
+
+REGISTER_ARG_ARG(  t, telnetport,  "network","telnetport",        "Port to use for network debug output",               "port" );
+REGISTER_ARG_ARG(  _, write_dict,  "compression", "writedict",    "write packets to DATA/dicts/newdict",               "numBytes" );
+
 
 /**
Index: /trunk/src/story_entities/multi_player_world.cc
===================================================================
--- /trunk/src/story_entities/multi_player_world.cc	(revision 7953)
+++ /trunk/src/story_entities/multi_player_world.cc	(revision 7954)
@@ -81,5 +81,5 @@
 void MultiPlayerWorld::synchronize()
 {
-  NetworkManager::getInstance()->synchronize();
+  NetworkManager::getInstance()->synchronize(this->dtS);
 }
 
Index: /trunk/src/story_entities/multi_player_world_data.cc
===================================================================
--- /trunk/src/story_entities/multi_player_world_data.cc	(revision 7953)
+++ /trunk/src/story_entities/multi_player_world_data.cc	(revision 7954)
@@ -226,4 +226,21 @@
     PNode::getNullParent()->init();
   }
+    // Fill the EntityLists. Tick then Draw:
+  this->tickLists.push_back(OM_DEAD_TICK);
+  this->tickLists.push_back(OM_ENVIRON);
+  this->tickLists.push_back(OM_COMMON);
+  this->tickLists.push_back(OM_GROUP_00);
+  this->tickLists.push_back(OM_GROUP_00_PROJ);
+  this->tickLists.push_back(OM_GROUP_01);
+  this->tickLists.push_back(OM_GROUP_01_PROJ);
+
+  this->drawLists.push_back(OM_ENVIRON_NOTICK);
+  this->drawLists.push_back(OM_ENVIRON);
+  this->drawLists.push_back(OM_COMMON);
+  this->drawLists.push_back(OM_GROUP_00);
+  this->drawLists.push_back(OM_GROUP_00_PROJ);
+  this->drawLists.push_back(OM_GROUP_01);
+  this->drawLists.push_back(OM_GROUP_01_PROJ);
+  
   State::setPlayer(this->localPlayer);
 }
Index: /trunk/src/subprojects/network/Makefile.am
===================================================================
--- /trunk/src/subprojects/network/Makefile.am	(revision 7953)
+++ /trunk/src/subprojects/network/Makefile.am	(revision 7954)
@@ -1,16 +1,21 @@
 MAINSRCDIR=../..
 include $(MAINSRCDIR)/defs/include_paths.am
+
+LIB_PREFIX=$(MAINSRCDIR)/lib
+include $(MAINSRCDIR)/lib/BuildLibs.am
+
 
 bin_PROGRAMS = network
 
 
-network_CPPFLAGS = -DNO_SHELL -DNO_SHELL_COMMAND
+network_CPPFLAGS = 
+#-DNO_SHELL -DNO_SHELL_COMMAND
 
-DEPENDENCIES = \
+network_DEPENDENCIES = \
 		$(MAINSRCDIR)/world_entities/libORXwe.a \
 		$(libORXlibs_a_LIBRARIES_) \
 		$(MAINSRCDIR)/util/libORXutils.a
 
-LDADD = \
+network_LDADD = \
 		$(MAINSRCDIR)/util/libORXutils.a \
 		$(libORXlibs_a_LIBRARIES_) \
Index: /trunk/src/subprojects/network/network_unit_test.cc
===================================================================
--- /trunk/src/subprojects/network/network_unit_test.cc	(revision 7953)
+++ /trunk/src/subprojects/network/network_unit_test.cc	(revision 7954)
@@ -9,7 +9,13 @@
 #include "network_socket.h"
 #include "server_socket.h"
+#include "udp_server_socket.h"
+#include "udp_socket.h"
 #include "network_stream.h"
 #include "synchronizeable.h"
 #include "converter.h"
+#include "state.h"
+#include "shared_network_data.h"
+#include "message_manager.h"
+#include "network_log.h"
 
 #include "simple_sync.h"
@@ -36,16 +42,25 @@
 int testSocket(int argc, char** argv)
 {
-  IPaddress ip;
-  SDLNet_ResolveHost(&ip, "127.0.0.1", 9999);
-  ServerSocket server;
-  server.listen(9999);
-
-  NetworkSocket* client1 = new NetworkSocket(ip);
-
-  NetworkSocket* server1 = server.getNewSocket();
-
-  NetworkSocket* client2 = new NetworkSocket(ip);
-
-  NetworkSocket* server2 = server.getNewSocket();
+  UdpServerSocket server(9999);
+
+  NetworkSocket* client1 = new UdpSocket("localhost", 9999);
+
+  NetworkSocket* server1 = NULL;
+  while ( server1 == NULL )
+  {
+    server.update();
+    server1 = server.getNewSocket();
+  }
+  
+  assert( server1->isOk() );
+
+  NetworkSocket* client2 = new UdpSocket("localhost", 9999);
+
+  NetworkSocket* server2 = NULL;
+  while ( server2 == NULL )
+  {
+    server.update();
+    server2 = server.getNewSocket();
+  }
 
   char buf[1024];
@@ -70,5 +85,7 @@
   n = server2->writePacket((byte*)str4, strlen(str4)+1);
   printf("%d bytes send from server2\n", n);
-  SDL_Delay(1000);
+  SDL_Delay(10);
+  
+  server.update();
 
   printf("read from server1\n");
@@ -103,7 +120,53 @@
 
   printf("data: '%s'\n", buf);
+  
+  
+  //22222222222222222222222222222222222222222
+  n = client1->writePacket((byte*)str1, strlen(str1)+1);
+  printf("%d bytes send from client1\n", n);
+  n = server1->writePacket((byte*)str2, strlen(str2)+1);
+  printf("%d bytes send from server1\n", n);
+  n = client2->writePacket((byte*)str3, strlen(str3)+1);
+  printf("%d bytes send from client2\n", n);
+  n = server2->writePacket((byte*)str4, strlen(str4)+1);
+  printf("%d bytes send from server2\n", n);
+  SDL_Delay(10);
+  
+  server.update();
+
+  printf("read from server1\n");
+  n = server1->readPacket((byte*)buf, 1024);
+  printf("read %d bytes\n", n);
+  if (n<0)
+    return -1;
+
+  printf("data: '%s'\n", buf);
+
+  printf("read from server2\n");
+  n = server2->readPacket((byte*)buf, 1024);
+  printf("read %d bytes\n", n);
+  if (n<0)
+    return -1;
+
+  printf("data: '%s'\n", buf);
+
+  printf("read from client1\n");
+  n = client1->readPacket((byte*)buf, 1024);
+  printf("read %d bytes\n", n);
+  if (n<0)
+    return -1;
+
+  printf("data: '%s'\n", buf);
+
+  printf("read from client2\n");
+  n = client2->readPacket((byte*)buf, 1024);
+  printf("read %d bytes\n", n);
+  if (n<0)
+    return -1;
+
+  printf("data: '%s'\n", buf);
 
   //sending bigger packets than 255 is not supported
-
+#if 0
   printf("try to send more than 255 bytes\n");
   printf("result: %d\n", client1->writePacket((byte*)buf, 1000));
@@ -113,5 +176,11 @@
   printf("try to read with a too small buffer\n");
   printf("result: %d\n", client1->readPacket((byte*)buf, strlen(str1)));
-
+#endif
+
+  delete client1;
+  delete client2;
+  delete server1;
+  delete server2; 
+  
   return 0;
 }
@@ -124,6 +193,6 @@
   printf("=================\n");
 
-  Synchronizeable* clientSync = new SimpleSync("Client\0");
-  Synchronizeable* serverSync = new SimpleSync("Server\0");
+  Synchronizeable* clientSync = new SimpleSync( std::string("Client") );
+  Synchronizeable* serverSync = new SimpleSync( std::string("Server") );
 
   unsigned int port = 9999;
@@ -144,5 +213,6 @@
   if(error == -1)
     printf("\n\nerror on address resolution, program inconsistancy\n\n");
-  nm->establishConnection(ip, *clientSync);
+  nm->establishConnection("localhost", port);
+  nm->connectSynchronizeable( *clientSync );
   /* adding some break for connection setup */
   SDL_Delay(20);
@@ -151,5 +221,5 @@
   for( int i = 0; i < 3; i++)
   {
-    nm->synchronize();
+    nm->synchronize( 1000 );
     /* simulate the network delay */
     SDL_Delay(50);
@@ -168,5 +238,9 @@
 }
 
-
+bool testCB( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
+{
+  printf("GOT MESSAGE: %s\n", data);
+  return true;
+}
 
 /**
@@ -178,24 +252,32 @@
 int startServer(int argc, char** argv)
 {
-  if( argc <= 2)
-  {
-    printf(" Wrong arguments try following notations:\n");
-    printf("   --server [port number]\n");
-    return 0;
-  }
-
-  int port = atoi(argv[2]);
-  printf("Starting Server on port %i\n", port);
+
+
+  State::setOnline(true);
+  SharedNetworkData::getInstance()->setGameServer( true );
+  printf("Starting Server on port %i\n", 9999);
 
   NetworkManager* netMan = NetworkManager::getInstance();
-  Synchronizeable* ss = new SimpleSync("Server\0");
-
-  netMan->createServer(/**ss, */port);
+  
+  netMan->initialize();
+  
+  netMan->createServer(/**ss, */ 9999);
+  
+  SimpleSync* ss = new SimpleSync("Server");
+  ss->setSynchronized( true );
+  
+  NetworkLog::getInstance()->listen( 8888 );
+
+  //MessageManager::getInstance()->initUser( 1 );
+  MessageManager::getInstance()->registerMessageHandler( TESTMESSAGEID, testCB, NULL );
+  
   SDL_Delay(20);
 
   for(;;)
   {
-    netMan->synchronize();
-    SDL_Delay(1000);
+    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"server to client", 18, RT_ALL, 0, MP_HIGHBANDWIDTH );
+    netMan->synchronize( 100 );
+    SDL_Delay(100);
+    ss->debug();
   }
 
@@ -210,9 +292,58 @@
 int startClient(int argc, char** argv)
 {
+
+
+  State::setOnline(true);
+  NetworkManager* netMan = NetworkManager::getInstance();
+  
+
+  netMan->initialize();
+  
+  std::string host;
+  
+  if ( argc > 2 )
+    host = argv[2];
+  else
+    host = "localhost";
+  
+  netMan->establishConnection(host, 9999);
+  
+//  SimpleSync* ss = new SimpleSync("SimpleSync");
+//  ss->setSynchronized( true );
+//  netMan->connectSynchronizeable( *ss );
+  
+  NetworkLog::getInstance()->listen( 7777 );
+
+  SimpleSync * ss = NULL;
+  
+  //MessageManager::getInstance()->initUser( 0 );
+  MessageManager::getInstance()->registerMessageHandler( TESTMESSAGEID, testCB, NULL );
+  
+  for(;;)
+  {
+    netMan->synchronize( 100 );
+    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"client to server", 18, RT_ALL, 0, MP_HIGHBANDWIDTH );
+    ss = dynamic_cast<SimpleSync*>(ClassList::getObject( "Server", CL_SIMPLE_SYNC ) );
+    SDL_Delay(100);
+    if (ss)
+      ss->debug();
+  }
+
+
+  delete netMan;
+  delete ss;
+
+  return 0;
+}
+
+
+
+int startListen(int argc, char** argv)
+{
   if( argc < 3)
   {
     printf(" Wrong arguments try following notations:\n");
-    printf("   --client [server ip] [port number]\n");
-    printf("   --client [server name] [port number]\n");
+    printf("   --listen [server ip] [port number]\n");
+    printf("   --listen [server name] [port number]\n");
     return 0;
   }
@@ -228,12 +359,13 @@
 
   NetworkManager* netMan = NetworkManager::getInstance();
-  Synchronizeable* ss = new SimpleSync("Client\0");
-
-  netMan->establishConnection((const char*)"localhost", port/*,ip, *ss*/);
+  Synchronizeable* ss = new SimpleSync("SimpleSync\0");
+
+  netMan->establishConnection( name, port );
+  netMan->connectSynchronizeable( *ss );
 
   for(;;)
   {
-    netMan->synchronize();
-    SDL_Delay(500);
+    netMan->synchronize( 1000 );
+    SDL_Delay(10);
   }
 
@@ -245,45 +377,7 @@
 }
 
-
-
-int startListen(int argc, char** argv)
-{
-  if( argc < 3)
-  {
-    printf(" Wrong arguments try following notations:\n");
-    printf("   --listen [server ip] [port number]\n");
-    printf("   --listen [server name] [port number]\n");
-    return 0;
-  }
-
-  char* name = argv[2];
-  int port = atoi(argv[3]);
-  printf("Connecting to %s, on port %i\n", name, port);
-
-  IPaddress ip;
-  int error = SDLNet_ResolveHost(&ip, name, port);
-  if(error == -1)
-    printf("\n\nerror on address resolution, program inconsistancy\n\n");
-
-  NetworkManager* netMan = NetworkManager::getInstance();
-  Synchronizeable* ss = new ReadSync("WriteSync\0");
-
-  netMan->establishConnection(ip, *ss);
-
-  for(;;)
-  {
-    netMan->synchronize();
-    SDL_Delay(10);
-  }
-
-
-  delete netMan;
-  delete ss;
-
-  return 0;
-}
-
 void testFloatConverter(float f)
 {
+#if 0
   char* s = Converter::floatToBinString(f);
   printf("%f = ", f);
@@ -293,13 +387,15 @@
   printf("Byte Array: ");
   for (int i = 0; i < 4; i++)
-    printf("%i  ", res[i]);
+//    printf("%i  ", res[i]);
   printf("\n");
 
   float b = Converter::byteArrayToFloat(res);
   printf("ReConvert: %f \n", b);
+#endif
 }
 
 void testFloatConverter2(float f)
 {
+#if 0
   char* s = Converter::floatToBinString(f);
   printf("### %f = ", f);
@@ -314,4 +410,5 @@
   float b = Converter::_byteArrayToFloat(res);
   printf("ReConvert: %f \n", b);
+#endif
 }
 int converter(int argc, char** argv)
@@ -435,8 +532,8 @@
 
 
-bool ShellBuffer::addBufferLineStatic(const char* line, ...)
-{
+//bool ShellBuffer::addBufferLineStatic(const char* line, ...)
+//{
   //va_list arguments;
   //vprintf(line, arguments);
-  printf("%s", line);
-}
+  //  printf("%s", line);
+//}
Index: /trunk/src/subprojects/network/simple_sync.cc
===================================================================
--- /trunk/src/subprojects/network/simple_sync.cc	(revision 7953)
+++ /trunk/src/subprojects/network/simple_sync.cc	(revision 7954)
@@ -22,5 +22,11 @@
 #include "simple_sync.h"
 
+#include "class_id.h"
+#include "fast_factory.h"
+#include "lib/util/loading/factory.h"
+
 #include "debug.h"
+
+CREATE_FACTORY(SimpleSync, CL_SIMPLE_SYNC);
 
 
@@ -28,24 +34,13 @@
  *  default constructor
  */
-SimpleSync::SimpleSync(const char* name)
-  : Synchronizeable()
+SimpleSync::SimpleSync( std::string name )
 {
-  /* define the local buffer size */
-  this->outLength = 10;
-  this->recLength = 0;
-  this->inLength = 40;
-  this->outData = new byte[this->outLength];
-  this->inData = new byte[this->inLength];
-
-  /* init the buffer data */
-  for( int i = 0; i < this->outLength; i++)
-  {
-    this->outData[i] = i;
-  }
-  for( int i = 0; i < this->inLength; i++)
-  {
-    this->inData[i] = 0;
-  }
-
+  setName( name );
+  this->setClassID( CL_SIMPLE_SYNC, "SimpleSync" );
+  in = 0;
+  out = 1;
+  syncStr = "hallo test test";
+  id = this->registerVarId( new SynchronizeableInt( &in, &out, "var", PERMISSION_ALL ) );
+  registerVar( new SynchronizeableString( &syncStr, &syncStr, "syncStr" ) );
 }
 
@@ -56,68 +51,24 @@
 SimpleSync::~SimpleSync()
 {
-  if( this->outData)
-    delete[] this->outData;
-  if( this->inData)
-    delete[] this->inData;
+}
+
+void SimpleSync::debug( )
+{
+  printf("IN: %d OUT: %d\n", in, out);
+  printf("str: %s\n", syncStr.c_str());
+}
+
+SimpleSync::SimpleSync( const TiXmlElement * root )
+{
+  setName( "" );
+  this->setClassID( CL_SIMPLE_SYNC, "SimpleSync" );
+  in = 0;
+  out = 1;
+  syncStr = "hallo test test";
+  id = this->registerVarId( new SynchronizeableInt( &in, &out, "var", PERMISSION_ALL ) );
+  registerVar( new SynchronizeableString( &syncStr, &syncStr, "syncStr" ) );
 }
 
 
-/**
- *  write data to Synchronizeable
- */
-int SimpleSync::writeBytes(const byte* data, int length, int sender)
-{
-  PRINTF(0)("SimpleSync: got %i bytes of data\n", length);
-  this->recLength = length;
-  if(this->inLength < length)
-    PRINTF(0)("ERROR: local buffer is smaller than the data to receive.\n");
-
-  /* copy the data localy */
-  for( int i = 0; i < length; i++)
-  {
-    this->inData[i] = data[i];
-  }
-  /* and debug output */
-  this->writeDebug();
-}
 
 
-/**
- *  read data from Synchronizeable
- */
-int SimpleSync::readBytes(byte* data, int maxLength, int * reciever)
-{
-  PRINTF(0)("SimpleSync: sent %i bytes of data\n", this->outLength);
-
-  /* debug msg */
-  this->readDebug();
-
-  /* write the test message */
-  for( int i = 0; i < this->outLength; i++)
-    data[i] = this->outData[i];
-
-  /* return the length of the test */
-  return this->outLength;
-}
-
-
-void SimpleSync::writeDebug() const
-{
-  PRINTF(0)("Write in bytes: \t(0 <-) |");
-  for(int i = 0; i < this->recLength; i++)
-  {
-    PRINT(0)(" [%u] ",this->inData[i]);
-  }
-  PRINT(0)("|\n");
-}
-
-
-void SimpleSync::readDebug() const
-{
-  PRINTF(0)("Read out bytes: \t(0 ->) |");
-  for(int i = 0; i < this->outLength; i++)
-  {
-    PRINT(0)(" [%u] ",this->outData[i]);
-  }
-  PRINT(0)("|\n");
-}
Index: /trunk/src/subprojects/network/simple_sync.h
===================================================================
--- /trunk/src/subprojects/network/simple_sync.h	(revision 7953)
+++ /trunk/src/subprojects/network/simple_sync.h	(revision 7954)
@@ -13,22 +13,16 @@
   {
   public:
-    SimpleSync(const char* name);
+    SimpleSync( std::string name);
+    SimpleSync(const TiXmlElement* root = NULL);
     virtual ~SimpleSync();
-
-    virtual int writeBytes(const byte* data, int length, int sender);
-    virtual int readBytes(byte* data, int maxLength, int * reciever);
+    
+    void debug();
 
 
   private:
-    virtual void writeDebug() const;
-    virtual void readDebug() const;
-
-
-  private:
-    byte* inData;
-    int   inLength;
-    int   recLength;
-    byte* outData;
-    int   outLength;
+    int in;
+    int out;
+    std::string syncStr;
+    int id;
   };
 
Index: /trunk/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- /trunk/src/util/multiplayer_team_deathmatch.cc	(revision 7953)
+++ /trunk/src/util/multiplayer_team_deathmatch.cc	(revision 7954)
@@ -203,10 +203,7 @@
       if ( terrz < terrain->getHeight( terrx, terry ) && ss->getAbsCoor().x > -1000 )
       {
-        //PRINTF(0)("COLLLLLLIIIIIDDDDEEEE\n");
-        ss->networkCollisionList.push_back( 1234567890 );
-        ss->doCollideNetwork( 1234567890 );
+        //TODO handle this
       }
-      //PRINTF(0)("x = %f, y = %f, z = %f, height = %f\n", terrx, terry, terrz, terrain->getHeight( terrx, terry ));
-      //ss->setRelCoorSoft( ss->getAbsCoor().x, terrain->getHeight( terrx, terry )-offsety, ss->getAbsCoor().z );
+
 
       float dist = (dynamic_cast<Playable*>(*it)->getAbsCoor() - big_left).len();
@@ -222,6 +219,5 @@
         if((*it)->isA(CL_SPACE_SHIP))
         {
-          dynamic_cast<SpaceShip*>(*it)->networkCollisionList.push_back(1163692);
-          dynamic_cast<SpaceShip*>(*it)->doCollideNetwork(11636922);
+          //TODO handle this
         }
       }
Index: /trunk/src/world_entities/environments/water.cc
===================================================================
--- /trunk/src/world_entities/environments/water.cc	(revision 7953)
+++ /trunk/src/world_entities/environments/water.cc	(revision 7954)
@@ -59,4 +59,10 @@
   // To test the Wave equation
   //this->wave(5.0,4.0, 1, 10);
+  
+  height_handle = registerVarId( new SynchronizeableFloat( &height, &height, "height" ) );
+  resX_handle = registerVarId( new SynchronizeableUInt( &resX, &resX, "resX" ) );
+  resY_handle = registerVarId( new SynchronizeableUInt( &resY, &resY, "resY" ) );
+  sizeX_handle = registerVarId( new SynchronizeableFloat( &sizeX, &sizeX, "sizeX" ) );
+  sizeY_handle = registerVarId( new SynchronizeableFloat( &sizeY, &sizeY, "sizeY" ) );
 }
 
@@ -291,116 +297,21 @@
 
 
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int Water::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( Water::writeState, NWT_WAT_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int Water::readBytes( byte * data, int maxLength, int * reciever )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-    SYNCHELP_WRITE_FKT( Water::readState, NWT_WAT_STATE );
-  }
-
-  *reciever = 0;
-  return SYNCHELP_WRITE_N;
-}
-
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int Water::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_WAT_WE_STATE );
-
-  // sync the size
-  SYNCHELP_WRITE_FLOAT( this->sizeX, NWT_WAT_SIZEX );
-  SYNCHELP_WRITE_FLOAT( this->sizeY, NWT_WAT_SIZEY );
-
-  //sync resolution
-  SYNCHELP_WRITE_INT( this->resX, NWT_WAT_RESX );
-  SYNCHELP_WRITE_INT( this->resY, NWT_WAT_RESY );
-
-  //sync the height
-  SYNCHELP_WRITE_FLOAT( this->height, NWT_WAT_HEIGHT );
-
-  return SYNCHELP_WRITE_N;
-}
-
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int Water::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_WAT_WE_STATE );
-
-  float f1, f2;
-  int i1, i2;
-
-  //read the size
-  SYNCHELP_READ_FLOAT( f1, NWT_WAT_SIZEX );
-  SYNCHELP_READ_FLOAT( f2, NWT_WAT_SIZEY );
-  this->sizeX = f1;
-  this->sizeY = f2;
-  PRINTF(0)("Setting Water to size: %f x %f\n", f1, f2);
-
-  //read the resolution
-  SYNCHELP_READ_INT( i1, NWT_WAT_RESX );
-  SYNCHELP_READ_INT( i2, NWT_WAT_RESY );
-  this->resX = i1;
-  this->resY = i2;
-  PRINTF(0)("Setting Water to resolution: %i x %i\n", i1, i2);
-
-  //read the height
-  SYNCHELP_READ_FLOAT( f1, NWT_WAT_HEIGHT );
-  this->height = f1;
-
-  this->rebuildGrid();
-
-  return SYNCHELP_READ_N;
-}
-
-
+
+/**
+ * function to handle changes in synced vars
+ * @param id ids which have changed
+ */
+void Water::varChangeHandler( std::list< int > & id )
+{
+  if ( std::find( id.begin(), id.end(), height_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), resX_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), resY_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), sizeX_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), sizeY_handle ) != id.end()
+     )
+  {
+    this->rebuildGrid();
+  }
+  
+  WorldEntity::varChangeHandler( id );
+}
Index: /trunk/src/world_entities/environments/water.h
===================================================================
--- /trunk/src/world_entities/environments/water.h	(revision 7953)
+++ /trunk/src/world_entities/environments/water.h	(revision 7954)
@@ -38,10 +38,6 @@
    void draw() const;
    void tick(float dt);
-
-   virtual int writeBytes(const byte* data, int length, int sender);
-   virtual int readBytes(byte* data, int maxLength, int * reciever);
-
-   int writeState( const byte * data, int length, int sender );
-   int readState( byte * data, int maxLength );
+   
+   virtual void varChangeHandler( std::list<int> & id );
 
   private:
@@ -56,8 +52,14 @@
     Material        waterMaterial;
     Shader*         waterShader;
+    
     float           height;          //!< The hight of the Water
+    int             height_handle;   //!< Handle to notify about changes of height
 
-    unsigned int    resX, resY;
-    float           sizeX, sizeY;
+    unsigned int    resX, resY;      //!< Grid resolution
+    int             resX_handle;     //!< Handle to notify about changes of resX
+    int             resY_handle;     //!< Handle to notify about changes of resY
+    float           sizeX, sizeY;    //!< waters size
+    int             sizeX_handle;    //!< Handle to notify about changes of sizeX
+    int             sizeY_handle;    //!< Handle to notify about changes of sizeY
 
     float phase;
Index: /trunk/src/world_entities/npcs/ground_turret.cc
===================================================================
--- /trunk/src/world_entities/npcs/ground_turret.cc	(revision 7953)
+++ /trunk/src/world_entities/npcs/ground_turret.cc	(revision 7954)
@@ -180,49 +180,2 @@
   Explosion::explode(this, Vector(10,10,10));
 }
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int GroundTurret::writeBytes( const byte * data, int length, int sender )
-{
-  setRequestedSync( false );
-  setIsOutOfSync( false );
-
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( WorldEntity::writeState, NWT_GT_WE_STATE );
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int GroundTurret::readBytes( byte * data, int maxLength, int * reciever )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( isOutOfSync() && !requestedSync() && this->getHostID()!=this->getOwner() )
-  {
-    (NetworkGameManager::getInstance())->sync( this->getUniqueID(), this->getOwner() );
-    setRequestedSync( true );
-  }
-
-  int rec = this->getRequestSync();
-  if ( rec > 0 )
-  {
-    *reciever = rec;
-
-    SYNCHELP_WRITE_FKT( WorldEntity::readState, NWT_GT_WE_STATE );
-
-  }
-
-  *reciever = 0;
-  return SYNCHELP_WRITE_N;
-}
